// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int from = -1000, to = 1000;

	int maxv = 1000;

	if (__testlib_opts.count("from")) {
		from = max(from, opt<int>("from"));
	}

	if (__testlib_opts.count("to")) {
		to = min(to, opt<int>("to"));
	}

	if (__testlib_opts.count("group3")) {
		to = min(to, 1);
	}

	if (__testlib_opts.count("sol_exist")) {
		from = max(0, from);
	}

	if (__testlib_opts.count("group4")) {
		maxv = 100;
		to = min(to, 100);
	}

	int act_from = from;

	if (__testlib_opts.count("single_fail") || __testlib_opts.count("last_fail")) {
		from = max(from, 0);
		to = min(to, 10);
	}

	vector<int> szs = {opt<int>(argc - 1)};
	vector<int> chs;

	while (szs.back() <= maxv) {
		int next;
		while (true) {
			next = szs.back() * 2 + rnd.next(from, to);
			if (szs.back() < next) {
				break;
			}
		}

		// cerr << next << endl;

		chs.push_back(next - szs.back() * 2);
		szs.push_back(next);
	}

	szs.pop_back();
	chs.pop_back();

	if (__testlib_opts.count("single_fail")) {
		chs[rnd.next(szof(chs))] = -1;
	}

	if (__testlib_opts.count("last_fail")) {
		chs.back() = -1;
	}

	szs.resize(1);
	for (int ch : chs) {
		szs.push_back(szs.back() * 2 + ch);
	}

	cout << szof(szs) << "\n";

	for (int i = 0; i < szof(szs); ++i) {
		cout << szs[i];
		if (i < szof(szs) - 1) {
			cout << " ";
		}
	}
	cout << "\n";

	return 0;
}