#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int cur_test = -1;
const int MAXN[5] = {10, 3, 10, 50, 1000};
const int MINH = 100;
const int MAXH = 1000;

void write_test(vector<int> a) 
{
    startTest(cur_test++);
    cerr << cur_test << endl;
    cout << a.size() << endl;
    for (int i = 0; i < int(a.size()) - 1; i++)
        cout << a[i] << ' ';
    cout << a.back() << endl;
}

void gen3()
{
    int m[3];
    m[0] = rnd.next(MINH, MAXH - 42);
    m[1] = rnd.next(m[0] + 21, MAXH - 21);
    m[2] = rnd.next(m[1], MAXH);
    vector<int> a(3);
    for (int i = 0; i < 27; i++)
    {
        for (int j = 0, k = 1; j < 3; j++, k *= 3)
            a[j] = m[(i / k) % 3];   
        write_test(a);
    }
}

void gen_equal(int n)
{
    vector<int> a(n);
    int m = rnd.next(MINH, MAXH);
    for (int i = 0; i < n; i++)
    {
        a[i] = m;
    }
    write_test(a);
}

void gen_max_ans(int maxn)
{
    vector<int> a(1, MINH);
    int cur = MINH + 21;
    while (a.size() < maxn && cur <= MAXH)
    {
        a.push_back(cur);
        cur += 21;
    }
    shuffle(a.begin(), a.end());
    write_test(a);
}

void gen_max_ans3(int maxn)
{
    vector<int> a(1, MINH);
    int cur = MINH + 20;
    while (a.size() < maxn && cur <= MAXH)
    {
        a.push_back(cur);
        cur += 20;
    }
    shuffle(a.begin(), a.end());
    write_test(a);
}

void gen_max_ans2(int maxn)
{
    vector<int> a(1, MINH);
    int cur = MINH + 11;
    while (a.size() < maxn && cur <= MAXH)
    {
        a.push_back(cur);
        cur += 11;
    }
    shuffle(a.begin(), a.end());
    write_test(a);
}

void gen_max_ans4(int maxn)
{
    vector<int> a(1, MINH);
    int cur = MINH + 10;
    while (a.size() < maxn && cur <= MAXH)
    {
        a.push_back(cur);
        cur += 10;
    }
    shuffle(a.begin(), a.end());
    write_test(a);
}

void gen_rand(int n)
{
    vector<int> a(n);
    for (int i = 0; i < n; i++)
    {
        a[i] = rnd.next(MINH, MAXH);
    }
    write_test(a);
}


int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);
    gen3();
    cerr << format("2nd group starts from test %d", cur_test) << endl;
    for (int i = 0; i < 2; i++) 
    {
        gen_equal(rnd.next(MAXN[2]/3, MAXN[2]));
        gen_rand(rnd.next(MAXN[2]/3, MAXN[2]));
        gen_rand(rnd.next(MAXN[2]/3, MAXN[2]));
        gen_max_ans(rnd.next(MAXN[2]/3, MAXN[2]));
        gen_max_ans2(rnd.next(MAXN[2]/3, MAXN[2]));
        gen_max_ans3(rnd.next(MAXN[2]/3, MAXN[2]));
        gen_max_ans4(rnd.next(MAXN[2]/3, MAXN[2]));
        
    }
    gen_equal(MAXN[2]);
    gen_rand(MAXN[2]);
    gen_max_ans(MAXN[2]);
    gen_max_ans2(MAXN[2]);
    gen_max_ans3(MAXN[2]);
    gen_max_ans4(MAXN[2]);


    cerr << format("3rd group starts from test %d", cur_test) << endl;
    for (int i = 0; i < 2; i++) 
    {
        gen_max_ans(rnd.next(MAXN[2], MAXN[3]));
        gen_max_ans2(rnd.next(MAXN[2], MAXN[3]));
        gen_max_ans3(rnd.next(MAXN[2], MAXN[3]));
    }
    gen_max_ans(MAXN[3]);
    gen_max_ans2(MAXN[3]);
    gen_max_ans3(MAXN[3]);


    cerr << format("4th group starts from test %d", cur_test) << endl;
    for (int i = 0; i < 2; i++) 
    {
        gen_equal(rnd.next(MAXN[3], MAXN[4]));
        gen_rand(rnd.next(MAXN[3], MAXN[4]));
        gen_rand(rnd.next(MAXN[3], MAXN[4]));
        
    }
    gen_equal(MAXN[4]);
    gen_rand(MAXN[4]);
    gen_max_ans2(MAXN[4]);
    gen_max_ans4(MAXN[4]);


    return 0;
}
